/*
  Copyright (C) 2002 INRIA, Ecole des Mines de Nantes, Univerity of Copenhagen
  Automatically generated from Bossa specification by the cb compiler
  --- Do not edit this file ---
  To compile for use as a module, compile with options "gcc -O -DMODULE"*/

/* checksum = 6698 */
#ifndef EXPORTS
#define EXPORTS fixed_priority_sched_ops
#endif
#ifndef NAME
#define NAME "fixed_priority"
#endif
#define VIRTUAL_SCHEDULER
struct Fixed_priority_bossa_struct;
#define PROTOCOL_PROCESS_STRUCT   struct bossa_struct
#define PROTOCOL_SCHEDULER_STRUCT struct Fixed_priority_bossa_struct
#define PROTOCOL_BOSSA_STRUCT     struct Fixed_priority_bossa_struct
/* Compile with options "gcc -O -D__KERNEL__ " */
#ifdef __KERNEL__
   #include <linux/sched.h>
   #include <linux/string.h>
   #include <linux/slab.h>
   #include <asm/mmu_context.h>
   #include <linux/interrupt.h>
   #include <linux/smp_lock.h>
   #include <linux/errno.h>
   #include <linux/list.h>
   #include <linux/prefetch.h>
#else
   struct timer_list { int x; };
   #include "bossa.h"
   struct task_struct { int pid; void *mm; char *comm; };
   #define kmalloc(x,y) malloc(x)
   #define kfree(x) free(x)
   #define GFP_ATOMIC 0
   #define panic printf
#endif
#define array_ref(x,y,z) x[y].z
#define UNBLOCK_INFO_OFFSET 0
#define drop_unblock_res(x) (x&~(1<<UNBLOCK_INFO_OFFSET))
#define get_unblock_res(x) (x&(1<<UNBLOCK_INFO_OFFSET))
#define set_current_need_resched(n) current->need_resched = n
#define SUCCESS 0
#define FAILURE -1
#include <linux/hrtime.h>
extern int bossa_tstojiffie(unsigned long, long, unsigned long *);
#define time_to_ticks(x) (x).tv_sec
#define time_to_jiffies(x) (x).tv_sec
#define time_to_subjiffies(x) (x).tv_nsec
#define make_cycles(x) x
#define make_cycle_time(x,y) {x,y}
static struct timespec global_time_tmp;
static inline struct timespec ticks_to_time(int x) {
  global_time_tmp.tv_sec = x; global_time_tmp.tv_nsec = 0;
  return global_time_tmp;
}
#define tstojiffie(x,y,z) bossa_tstojiffie(x,y,&z)
#define call_normalize_time(x,y,z) normalize_time(x,y,&z)

/* includes for interface functions */
#include <linux/types.h>
//#include <linux/errno.h>
//#include <linux/sched.h>
#include <linux/fs.h>
#include <linux/unistd.h>
//#include <linux/slab.h>
#include <linux/devfs_fs_kernel.h>
#include <asm/uaccess.h>
#include <linux/ioctl.h>


#define bossa_assert(x) do{if(!(x)) panic("Error in " #x "\n");} while(0)
#define state_of(e) ((e)->state)
#define update_state(e,s,c) ((e)->state=(s))
#define event_mask0(e) ((e) & 0xff000000)
#define event_mask1(e) ((e) & 0xffff0000)
#define event_mask2(e) ((e) & 0xffffff00)
#define event_mask3(e) ((e) & 0xffffffff)
#define true 1
#define false 0
#define null NULL
typedef int bool;
typedef void * port;

#define  TERMINATED_12_STATE  1 << 0
#define  NOWHERE_11_STATE  0
#define  RUNNING_0_STATE  1 << 1
#define  READY_STATE  1 << 2
#define  YIELD_STATE  1 << 3
#define  BLOCKED_STATE  1 << 4

extern spinlock_t bossa_scheduler_lock;
extern struct bossa_struct *rts_idle_process;
struct Fixed_priority_bossa_struct {
  /* default attributes for Bossa */
  /* next and previous processes in the current bossa queue */
  struct list_head list_info;
  struct scheduler_operations *ops;
  int state;
  /* Additional process attributes
   *  specified by the scheduling policy
   *  in the process = {...} declaration
  */
  int importance;
};

extern enum SchedState root_s_state;

static int children = 0;

#ifdef MODULE
/************ Routines related to modules *************/
static int __init Fixed_priority_init_module(void);
static void __exit Fixed_priority_cleanup_module(void);
/******************************************************/
#endif
/******** to know if the module is being used ********/
static inline void increment_ref_count(void);
static inline void decrement_ref_count(void);
/******************************************************/

static void Fixed_priority_scheduler_init (void);
static int Fixed_priority_ioctl_init (void);
static int Fixed_priority_scheduler(struct event_struct *e,
                                    struct next_list_struct *src_next_list,
                                    struct next_list_struct *tgt_next_list);
static int Fixed_priority_compute_state(struct next_list_struct *next_list);
static int Fixed_priority_ps_attach(struct next_list_struct *next_list);
static int Fixed_priority_ps_detach(struct next_list_struct *next_list,
                                    struct bossa_struct *_p);
static int Fixed_priority_attach(struct Fixed_priority_bossa_struct *child,
                                 int data[]);
static int Fixed_priority_attach_info(char *info[]);
static int Fixed_priority_detach(struct Fixed_priority_bossa_struct *child, bool discard_child);
static struct scheduler_struct *
Fixed_priority_create_scheduler(struct scheduler_operations *ops, int);
static void Fixed_priority_attach_self(void);
static PROTOCOL_SCHEDULER_STRUCT *Fixed_priority_detach_self(bool is_root);
static uint Fixed_priority_check_process_state(struct bossa_struct *tgt,
                                               struct next_list_struct *next,
                                               uint classes);
static void Fixed_priority_preempt(void);
static char *
queueToString(struct list_head *start, char *buffer, bool long_format);
static int Fixed_priority_do_taskprocinfo(struct next_list_struct *, struct bossa_struct *, char *, bool, bool, bool);
static int Fixed_priority_do_schedprocinfo(char *, bool);
static int Fixed_priority_list_sched_info(char * page,char ** start,off_t off,
				 int count,int * eof,void * data);
static int Fixed_priority_count_processes(void);
static void Fixed_priority_print_processes(void);
static void Fixed_priority_set_priority(struct bossa_struct *, struct next_list_struct *, int);
inline static int Fixed_priority_block(
int,
struct bossa_struct *,
struct next_list_struct *);
inline static int Fixed_priority_block_bossa_schedule(void);
static int Fixed_priority_block_entry(int,
                                      struct bossa_struct *);
inline static int Fixed_priority_yield_system_immediate(int,
                                                        struct bossa_struct *,
                                                        struct next_list_struct *);
inline static int Fixed_priority_yield_system_immediate_bossa_schedule(void);
static int Fixed_priority_yield_system_immediate_entry(int,
                                                       struct bossa_struct *);
inline static int Fixed_priority_yield_system_pause(int,
                                                    struct bossa_struct *,
                                                    struct next_list_struct *);
inline static int Fixed_priority_yield_system_pause_bossa_schedule(void);
static int Fixed_priority_yield_system_pause_entry(int,
                                                   struct bossa_struct *);
inline static int Fixed_priority_unblock_preemptive(int,
                                                    struct bossa_struct *,
                                                    struct next_list_struct *);
static int Fixed_priority_unblock_preemptive_entry(int,
                                                   struct bossa_struct *);
inline static int Fixed_priority_bossa_schedule(void);
static int Fixed_priority_bossa_schedule_entry(void);
inline static int Fixed_priority_unblock_timer_target(int,
                                                      struct bossa_struct *,
                                                      struct next_list_struct *);
static int Fixed_priority_unblock_timer_target_entry(int,
                                                     struct bossa_struct *,
                                                     struct next_list_struct *);
inline static int Fixed_priority_unblock_timer_notarget(int,
                                                        struct bossa_struct *,
                                                        struct next_list_struct *);
static int Fixed_priority_unblock_timer_notarget_entry(int,
                                                       struct bossa_struct *,
                                                       struct next_list_struct *);

static char *sched_type[4] = {"Virtual Scheduler","Process Scheduler","VS","PS"};

struct scheduler_operations EXPORTS = {
  Fixed_priority_scheduler,
  (int (*)(int,struct bossa_struct *,struct next_list_struct *))Fixed_priority_block,
  Fixed_priority_block_bossa_schedule,
  (int (*)(int,struct bossa_struct *))Fixed_priority_block_entry,
  (int (*)(int,struct bossa_struct *,struct next_list_struct *))Fixed_priority_yield_system_immediate,
  Fixed_priority_yield_system_immediate_bossa_schedule,
  (int (*)(int,struct bossa_struct *))Fixed_priority_yield_system_immediate_entry,
  (int (*)(int,struct bossa_struct *,struct next_list_struct *))Fixed_priority_yield_system_pause,
  Fixed_priority_yield_system_pause_bossa_schedule,
  (int (*)(int,struct bossa_struct *))Fixed_priority_yield_system_pause_entry,
  (int (*)(int,struct bossa_struct *,struct next_list_struct *))Fixed_priority_unblock_preemptive,
  (int (*)(int,struct bossa_struct *))Fixed_priority_unblock_preemptive_entry,
  Fixed_priority_bossa_schedule,
  Fixed_priority_bossa_schedule_entry,
  (int (*)(int,struct bossa_struct *,struct next_list_struct *))Fixed_priority_unblock_timer_target,
  (int (*)(int,struct bossa_struct *,struct next_list_struct *))Fixed_priority_unblock_timer_target_entry,
  (int (*)(int,struct bossa_struct *,struct next_list_struct *))Fixed_priority_unblock_timer_notarget,
  (int (*)(int,struct bossa_struct *,struct next_list_struct *))Fixed_priority_unblock_timer_notarget_entry,
  "Fixed_priority",
  VS,
  true,
  Fixed_priority_scheduler_init,
  Fixed_priority_ioctl_init,
  Fixed_priority_create_scheduler,
  Fixed_priority_check_process_state,
  Fixed_priority_preempt,
  Fixed_priority_do_taskprocinfo,
  Fixed_priority_do_schedprocinfo,
  Fixed_priority_list_sched_info,
  Fixed_priority_count_processes,
  Fixed_priority_print_processes,
  Fixed_priority_set_priority,
  Fixed_priority_compute_state,
  Fixed_priority_ps_attach,
  Fixed_priority_ps_detach,
  Fixed_priority_attach,
  Fixed_priority_attach_info,
  Fixed_priority_detach,
  Fixed_priority_attach_self,
  Fixed_priority_detach_self,
  increment_ref_count,
  decrement_ref_count,
  { NULL, NULL }, // filled in at installation with the path to the scheduler
};

/* definition of protocol states */
#ifndef __KERNEL__
struct bossa_struct *running;
#endif
struct state_info {
  struct list_head terminated_12;
  struct Fixed_priority_bossa_struct *running_0;
  struct list_head ready;
  struct Fixed_priority_bossa_struct *yield; /* private */
  struct list_head blocked;
};


static struct state_info state_info __cacheline_aligned;


/*******************************************************
 *
 *	Modification Module
 *
 * *****************************************************/
#ifdef MODULE
   #include <linux/module.h> /* Ncessaire pour tous les modules */
   #include <linux/kernel.h> /* Ncessaire pour le alertes noyau */
   #include <linux/init.h>   /* Ncessaire pour l'utilisation module_init()/_exit()*/
   #include <linux/config.h> /* ?? */
static void unregister(void);
static char scheduler_string[] = "Virtual Scheduler with Fixed_priority";
static char scheduler_version[] = "1.0.1";
static char scheduler_copyright[] = "Copyright (c) 2002 INRIA, Ecole des Mines de Nantes, Univerity of Copenhagen.";

MODULE_AUTHOR("Bossa Compiler");
MODULE_DESCRIPTION("Loading of virtual scheduler Fixed_priority");
MODULE_LICENSE("GPL");

int bossa_add_scheduler(struct scheduler_operations *u_ops, int stat);
void bossa_remove_scheduler(struct scheduler_operations *u_ops);

/******************************************************************************
 * Fixed_priority_init_module - Scheduler Registration Routine
 *
 * Fixed_priority_init_module is the first routine called when the scheduler is
 * loaded. All it does is add to the list of scheduler and register with the
 * ioctl subsystem.
 * 
 ***************************************************************************/
static int __init Fixed_priority_init_module(void) 
{
  printk("<6>%s - version %s\n", scheduler_string, scheduler_version);
  printk(KERN_INFO "%s\n", scheduler_copyright);
  printk(KERN_INFO "Fixed_priority_scheduler_init function at %x\n", (unsigned int)Fixed_priority_scheduler_init);
  // add to all_schedulers
  if (bossa_add_scheduler(&EXPORTS,0)) return EINVAL;
  // init devfs thingy
  EXPORTS.ioctl_init();
  return 0;
}

module_init(Fixed_priority_init_module);
/******************************************************************************
 * Fixed_priority_cleanup_module - Scheduler Registration Routine
 *
 * Fixed_priority_cleanup_module is the first routine called when the scheduler is
 * unloaded. For instance she does nothing.
 * 
 ***************************************************************************/
static void __exit Fixed_priority_cleanup_module(void) 
{
  // unregister ioctl
  unregister();
  // remove the scheduler from the parent, if any
  if (EXPORTS.next_list.prev->prev != &EXPORTS.next_list)
    EXPORTS.next_list.prev->prev->sched->ops->detach(EXPORTS.next_list.prev->sched,true);
  // remove the scheduler from the list of all schedulers
  bossa_remove_scheduler(&EXPORTS);
  
  printk(KERN_INFO "scheduler %s unloaded\n",EXPORTS.name);
}

module_exit(Fixed_priority_cleanup_module);
#endif

static inline void increment_ref_count(void) {
#ifdef MODULE
  MOD_INC_USE_COUNT;
#endif
}

static inline void decrement_ref_count(void) {
#ifdef MODULE
  MOD_DEC_USE_COUNT;
#endif
}

/******* Fin de modification pour insertion modulaire *******/

#include "prim1.c"


inline static bool
greater(struct Fixed_priority_bossa_struct * p1_43,
        struct Fixed_priority_bossa_struct * p2_44) {
  int pv1_45;
  int pv2_46;
  
  pv1_45 = p1_43->importance;
  pv2_46 = p2_44->importance;
  return pv1_45 > pv2_46;
}

inline static int
key_index(struct Fixed_priority_bossa_struct * p_40) {
  int acc_42 = 0;
  
  return acc_42;
}

inline static int
static_compare(struct Fixed_priority_bossa_struct * p1_36,
               struct Fixed_priority_bossa_struct * p2_37) {
  {
    int pv1_38;
    int pv2_39;
    
    pv1_38 = p1_36->importance;
    pv2_39 = p2_37->importance;
    if (pv1_38 > pv2_39) {
      return 1;
    }
    else {
      if (pv1_38 < pv2_39) {
        return -1;
      }
    }
  }
  return 0;
}

inline static int
static_select_compare(struct Fixed_priority_bossa_struct * p1_32,
                      struct Fixed_priority_bossa_struct * p2_33) {
  return static_compare(p1_32, p2_33);
}

inline static bool
dynamic_select_greater(struct Fixed_priority_bossa_struct * p1_28,
                       struct Fixed_priority_bossa_struct * p2_29) {
  return false;
}

inline static bool
dynamic_greater(struct Fixed_priority_bossa_struct * p1_24,
                struct Fixed_priority_bossa_struct * p2_25) {
  return dynamic_select_greater(p1_24, p2_25);
}

static uint
Fixed_priority_check_process_state(struct bossa_struct *tgt,
                                   struct next_list_struct *next,
                                   uint classes) {
  return next->sched->ops->check_process_state(tgt,next->next,classes);
}

#include "prim.c"

#include "vsprim.c"

static struct scheduler_struct *
Fixed_priority_create_scheduler(struct scheduler_operations *ops,
                                int new_root) {
  struct Fixed_priority_bossa_struct *new;
  children++;
  new = (struct Fixed_priority_bossa_struct *)kmalloc(sizeof(struct Fixed_priority_bossa_struct),GFP_KERNEL);
  new->ops = ops;
  if (new_root) {
    if (root_s_state == RUNNING) {
      new->state = RUNNING_0_STATE;
      move_nowhere_proc(new,state_info.running_0);
    }
    else {
      new->state = READY_STATE;
      move_nowhere_queue(new,&state_info.ready);
    }
    // The following two lines make no sense
    // set_current_need_resched(1);
    // new->ops->preempt();
  }
  else {
    new->state = BLOCKED_STATE;
    move_nowhere_queue(new,&state_info.blocked);
  }
  return (struct scheduler_struct *)new;
}

static inline int forwardImmediate(struct Fixed_priority_bossa_struct *tgt,
                                   struct event_struct *e,
                                   struct next_list_struct *src_next_list,
                                   struct next_list_struct *tgt_next_list) {
  return tgt->ops->handle_event(e,src_next_list,tgt_next_list);
}

static void Fixed_priority_scheduler_init(void) {
  /* initialization of states */
  
  init_var(&state_info.running_0);
  init_queue(&state_info.ready);
  init_var(&state_info.yield);
  init_queue(&state_info.blocked);
}

static int Fixed_priority_scheduler(struct event_struct *e,
                                    struct next_list_struct *src_next_list,
                                    struct next_list_struct *tgt_next_list) {
  uint _event = (uint)e->type;
  
  prefetch(&state_info);
  switch (event_mask0(_event)) {
    case EVENT_PROCESS:
    {
      uint event_47 = event_mask1(_event);
      if (event_47 == EVENT_PROCESS_END) {
        {
          struct Fixed_priority_bossa_struct * _fresh_17 = tgt_next_list->sched;
          
          forwardImmediate(_fresh_17, e,
                           src_next_list->next,
                           tgt_next_list->next);
        }
        if (empty_proc(state_info.running_0)) {
          if (empty_queue(&state_info.ready)) {
            return BLOCKED;
          }
          else {
            return READY;
          }
        }
        else {
          return RUNNING;
        }
      }
      else if (event_47 == EVENT_PROCESS_NEW) {
        {
          struct Fixed_priority_bossa_struct * _fresh_19 = tgt_next_list->sched;
          
          if (forwardImmediate(_fresh_19, e,
                               src_next_list->next,
                               tgt_next_list->next) == READY) {
            if (state_of(_fresh_19) == RUNNING_0_STATE) {
              move_proc_sorted(state_info.running_0 /* {running_0} */,
                               &state_info.ready);
            }
            else {
              move_queue_sorted(_fresh_19 /* {ready, blocked} */,
                                &state_info.ready);
            }
            update_state(_fresh_19, READY_STATE, READY);
          }
        }
        if (empty_proc(state_info.running_0)) {
          return READY;
        }
        else {
          return RUNNING;
        }
      }
      else panic("unknown event %x\n",_event);
      return 0;
    }
    case EVENT_SYSTEM:
    {
      switch (forwardImmediate(state_info.running_0, e,
                               src_next_list->next,
                               tgt_next_list->next)) {
        case READY:
          {
            update_state(state_info.running_0, READY_STATE, READY);
            move_proc_sorted(state_info.running_0 /* {running_0} */,
                             &state_info.ready);
            break;
          }
        case BLOCKED:
          {
            update_state(state_info.running_0, BLOCKED_STATE, BLOCKED);
            move_proc_queue(state_info.running_0 /* {running_0} */,
                            &state_info.blocked);
            break;
          }
        default:
        {
          
        }
      }
      if (empty_proc(state_info.running_0)) {
        if (empty_queue(&state_info.ready)) {
          return BLOCKED;
        }
        else {
          return READY;
        }
      }
      else {
        return RUNNING;
      }
    }
    case EVENT_UNBLOCK:
    {
      {
        struct Fixed_priority_bossa_struct * _fresh_18 = tgt_next_list->sched;
        
        if (forwardImmediate(_fresh_18, e,
                             src_next_list->next,
                             tgt_next_list->next) == READY) {
          update_state(_fresh_18, READY_STATE, READY);
          move_queue_sorted(_fresh_18 /* {ready, blocked} */, &state_info.ready);
        }
      }
      if (empty_proc(state_info.running_0)) {
        if (empty_queue(&state_info.ready)) {
          return BLOCKED;
        }
        else {
          return READY;
        }
      }
      else {
        return RUNNING;
      }
    }
    case EVENT_YIELD:
    {
      if (state_of(tgt_next_list->sched) == RUNNING_0_STATE) {
        struct Fixed_priority_bossa_struct * s = state_info.running_0;
        bool toyield = !empty_queue(&state_info.ready);
        
        forwardImmediate(s, e,
                         src_next_list->next,
                         tgt_next_list->next);
        update_state(s, READY_STATE, READY);
        move_proc_sorted(state_info.running_0 /* {running_0} */,
                         &state_info.ready);
        if (toyield) {
          update_state(s, YIELD_STATE, READY);
          move_queue_proc(s /* {ready} */, state_info.yield);
          return READY;
        }
        else {
          return READY;
        }
      }
      else {
        if (empty_queue(&state_info.ready)) {
          return BLOCKED;
        }
        else {
          return READY;
        }
      }
    }
    default: {
      panic("unknown event %x\n",_event);
      return 0;
    }
  }
}

static int
Fixed_priority_compute_state(struct next_list_struct *tgt_next_list) {
  if (tgt_next_list->sched) {
    struct Fixed_priority_bossa_struct * _fresh_13 = tgt_next_list->sched;
    
    _fresh_13->ops->compute_state(tgt_next_list->next);
  }
  if (empty_proc(state_info.running_0)) {
    if (empty_proc(state_info.yield) && empty_queue(&state_info.ready)) {
      return BLOCKED;
    }
    else {
      return READY;
    }
  }
  else {
    return RUNNING;
  }
}

static void
Fixed_priority_preempt(void) {
  state_info.running_0->ops->preempt();
  update_state(state_info.running_0, READY_STATE, READY);
  move_proc_sorted(state_info.running_0 /* {running_0} */, &state_info.ready);
  return;
}

static int
Fixed_priority_ps_attach(struct next_list_struct *tgt_next_list) {
  {
    struct Fixed_priority_bossa_struct * _fresh_14 = tgt_next_list->sched;
    
    if (_fresh_14->ops->ps_attach(tgt_next_list->next) == READY) {
      update_state(_fresh_14, READY_STATE, READY);
      move_queue_sorted(_fresh_14 /* {ready, blocked} */, &state_info.ready);
    }
  }
  if (empty_proc(state_info.running_0)) {
    return READY;
  }
  else {
    return RUNNING;
  }
}

static int
Fixed_priority_ps_detach(struct next_list_struct *tgt_next_list,
                         struct bossa_struct *tgt) {
  {
    struct Fixed_priority_bossa_struct * _fresh_15 = tgt_next_list->sched;
    
    switch (_fresh_15->ops->ps_detach(tgt_next_list->next, tgt)) {
      case READY:
        {
          if (state_of(_fresh_15) == RUNNING_0_STATE) {
            move_proc_sorted(state_info.running_0 /* {running_0} */,
                             &state_info.ready);
            update_state(_fresh_15, READY_STATE, READY);
          }
          break;
        }
      case BLOCKED:
        {
          if (state_of(_fresh_15) == RUNNING_0_STATE) {
            move_proc_queue(state_info.running_0 /* {running_0} */,
                            &state_info.blocked);
          }
          else {
            move_queue_queue(_fresh_15 /* {ready, blocked} */,
                             &state_info.blocked);
          }
          update_state(_fresh_15, BLOCKED_STATE, BLOCKED);
          break;
        }
      default:
      {
        
      }
    }
  }
  if (empty_proc(state_info.running_0)) {
    if (empty_queue(&state_info.ready)) {
      return BLOCKED;
    }
    else {
      return READY;
    }
  }
  else {
    return RUNNING;
  }
}

inline static int
Fixed_priority_block(int _event,
                     struct bossa_struct *tgt,
                     struct next_list_struct *tgt_next_list) {
  prefetch(&state_info);
  {
    {
      struct Fixed_priority_bossa_struct * _fresh_16 = tgt_next_list->sched;
      
      if (_fresh_16->ops->block(_event, tgt, tgt_next_list->next) == READY) {
        if (state_of(_fresh_16) == RUNNING_0_STATE) {
          move_proc_sorted(state_info.running_0 /* {running_0} */,
                           &state_info.ready);
          update_state(_fresh_16, READY_STATE, READY);
        }
      }
      else {
        if (state_of(_fresh_16) == RUNNING_0_STATE) {
          move_proc_queue(state_info.running_0 /* {running_0} */,
                          &state_info.blocked);
        }
        else {
          move_queue_queue(_fresh_16 /* {ready, blocked} */,
                           &state_info.blocked);
        }
        update_state(_fresh_16, BLOCKED_STATE, BLOCKED);
      }
    }
    if (empty_queue(&state_info.ready)) {
      return BLOCKED;
    }
    else {
      return READY;
    }
  }
}

inline static int
Fixed_priority_block_bossa_schedule(void) {
  prefetch(&state_info);
  {
    {
      struct Fixed_priority_bossa_struct * _fresh_23 = select_sorted(
        &state_info.ready);
      
      _fresh_23->ops->block_bossa_schedule();
      update_state(_fresh_23, RUNNING_0_STATE, RUNNING);
      move_queue_proc(_fresh_23 /* {ready} */, state_info.running_0);
    }
    return RUNNING;
  }
}

static int Fixed_priority_block_entry(int _event,
                                      struct bossa_struct *tgt) {
  int res;
  res = Fixed_priority_block(_event,tgt,tgt->next_list->next->next);
  switch (res) {
    case BLOCKED: running = rts_idle_process;
    break;
    case READY:
    res = Fixed_priority_block_bossa_schedule();
  }
  return res;
}

inline static int
Fixed_priority_yield_system_immediate(int _event,
                                      struct bossa_struct *tgt,
                                      struct next_list_struct *tgt_next_list) {
  prefetch(&state_info);
  {
    if (state_of(tgt_next_list->sched) == RUNNING_0_STATE) {
      state_info.running_0->ops->yield_system_immediate(_event, tgt,
                                                        tgt_next_list->next);
      update_state(state_info.running_0, READY_STATE, READY);
      move_proc_sorted(state_info.running_0 /* {running_0} */,
                       &state_info.ready);
      return READY;
    }
    else {
      if (empty_queue(&state_info.ready)) {
        return BLOCKED;
      }
      else {
        return READY;
      }
    }
  }
}

inline static int
Fixed_priority_yield_system_immediate_bossa_schedule(void) {
  prefetch(&state_info);
  {
    {
      struct Fixed_priority_bossa_struct * _fresh_22 = select_sorted(
        &state_info.ready);
      
      _fresh_22->ops->yield_system_immediate_bossa_schedule();
      update_state(_fresh_22, RUNNING_0_STATE, RUNNING);
      move_queue_proc(_fresh_22 /* {ready} */, state_info.running_0);
    }
    return RUNNING;
  }
}

static int Fixed_priority_yield_system_immediate_entry(int _event,
                                                       struct bossa_struct *tgt) {
  int res;
  res = Fixed_priority_yield_system_immediate(_event,tgt,tgt->next_list->next->next);
  switch (res) {
    case BLOCKED: running = rts_idle_process;
    break;
    case READY:
    res = Fixed_priority_yield_system_immediate_bossa_schedule();
  }
  return res;
}

inline static int
Fixed_priority_yield_system_pause(int _event,
                                  struct bossa_struct *tgt,
                                  struct next_list_struct *tgt_next_list) {
  prefetch(&state_info);
  {
    if (state_of(tgt_next_list->sched) == RUNNING_0_STATE) {
      struct Fixed_priority_bossa_struct * s = state_info.running_0;
      bool toyield = !empty_queue(&state_info.ready);
      
      s->ops->yield_system_pause(_event, tgt, tgt_next_list->next);
      update_state(s, READY_STATE, READY);
      move_proc_sorted(state_info.running_0 /* {running_0} */,
                       &state_info.ready);
      if (toyield) {
        update_state(s, YIELD_STATE, READY);
        move_queue_proc(s /* {ready} */, state_info.yield);
        return READY;
      }
      else {
        return READY;
      }
    }
    else {
      if (empty_queue(&state_info.ready)) {
        return BLOCKED;
      }
      else {
        return READY;
      }
    }
  }
}

inline static int
Fixed_priority_yield_system_pause_bossa_schedule(void) {
  prefetch(&state_info);
  {
    if (empty_queue(&state_info.ready)) {
      update_state(state_info.yield, READY_STATE, READY);
      move_proc_sorted(state_info.yield /* {yield} */, &state_info.ready);
    }
    {
      struct Fixed_priority_bossa_struct * _fresh_21 = select_sorted(
        &state_info.ready);
      
      _fresh_21->ops->yield_system_pause_bossa_schedule();
      update_state(_fresh_21, RUNNING_0_STATE, RUNNING);
      move_queue_proc(_fresh_21 /* {ready} */, state_info.running_0);
    }
    if (empty_proc(state_info.yield)) {
      return RUNNING;
    }
    else {
      update_state(state_info.yield, READY_STATE, READY);
      move_proc_sorted(state_info.yield /* {yield} */, &state_info.ready);
      return RUNNING;
    }
  }
}

static int Fixed_priority_yield_system_pause_entry(int _event,
                                                   struct bossa_struct *tgt) {
  int res;
  res = Fixed_priority_yield_system_pause(_event,tgt,tgt->next_list->next->next);
  switch (res) {
    case BLOCKED: running = rts_idle_process;
    break;
    case READY:
    res = Fixed_priority_yield_system_pause_bossa_schedule();
  }
  return res;
}

inline static int
Fixed_priority_unblock_preemptive(int _event,
                                  struct bossa_struct *tgt,
                                  struct next_list_struct *tgt_next_list) {
  int fwdres = 0;
  prefetch(&state_info);
  {
    struct Fixed_priority_bossa_struct * nxt = tgt_next_list->sched;
    
    if (state_of(nxt) == BLOCKED_STATE) {
      fwdres = nxt->ops->unblock_preemptive(_event, tgt, tgt_next_list->next);
      if (drop_unblock_res(fwdres) == READY) {
        update_state(nxt, READY_STATE, READY);
        move_queue_sorted(nxt /* {blocked} */, &state_info.ready);
      }
      if (state_of(nxt) == READY_STATE) {
        if (empty_proc(state_info.running_0)) {
          return get_unblock_res(fwdres) | READY;
        }
        else {
          if (greater(nxt, state_info.running_0)) {
            state_info.running_0->ops->preempt();
            update_state(state_info.running_0, READY_STATE, READY);
            move_proc_sorted(state_info.running_0 /* {running_0} */,
                             &state_info.ready);
            return get_unblock_res(fwdres) | READY;
          }
          else {
            return get_unblock_res(fwdres) | RUNNING;
          }
        }
      }
      else {
        if (empty_proc(state_info.running_0)) {
          if (empty_proc(state_info.yield) && empty_queue(&state_info.ready)) {
            return get_unblock_res(fwdres) | BLOCKED;
          }
          else {
            return get_unblock_res(fwdres) | READY;
          }
        }
        else {
          return get_unblock_res(fwdres) | RUNNING;
        }
      }
    }
    else {
      fwdres = nxt->ops->unblock_preemptive(_event, tgt, tgt_next_list->next);
      if ((drop_unblock_res(fwdres) == READY) &&
          (!(state_of(nxt) == YIELD_STATE) &&
           (state_of(nxt) == RUNNING_0_STATE))) {
        move_proc_sorted(state_info.running_0 /* {running_0} */,
                         &state_info.ready);
        update_state(nxt, READY_STATE, READY);
      }
      if (empty_proc(state_info.running_0)) {
        return get_unblock_res(fwdres) | READY;
      }
      else {
        return get_unblock_res(fwdres) | RUNNING;
      }
    }
  }
}

static int Fixed_priority_unblock_preemptive_entry(int _event,
                                                   struct bossa_struct *tgt) {
  int res;
  int unblock_res;
  res = Fixed_priority_unblock_preemptive(_event,tgt,tgt->next_list->next->next);
  unblock_res = get_unblock_res(res);
  res = drop_unblock_res(res);
  root_s_state = res;
  return unblock_res;
}

inline static int
Fixed_priority_bossa_schedule(void) {
  prefetch(&state_info);
  {
    if (empty_queue(&state_info.ready)) {
      update_state(state_info.yield, READY_STATE, READY);
      move_proc_sorted(state_info.yield /* {yield} */, &state_info.ready);
    }
    {
      struct Fixed_priority_bossa_struct * _fresh_20 = select_sorted(
        &state_info.ready);
      
      _fresh_20->ops->bossa_schedule();
      update_state(_fresh_20, RUNNING_0_STATE, RUNNING);
      move_queue_proc(_fresh_20 /* {ready} */, state_info.running_0);
    }
    if (empty_proc(state_info.yield)) {
      return RUNNING;
    }
    else {
      update_state(state_info.yield, READY_STATE, READY);
      move_proc_sorted(state_info.yield /* {yield} */, &state_info.ready);
      return RUNNING;
    }
  }
}

static int Fixed_priority_bossa_schedule_entry(void) {
  int res;
  res = Fixed_priority_bossa_schedule();
  return res;
}

inline static int
Fixed_priority_unblock_timer_target(int _event,
                                    struct bossa_struct *tgt,
                                    struct next_list_struct *tgt_next_list) {
  uint __event;
  // ->prev below gets back to the current scheduler
  if (tgt_next_list->prev->sched->ops == &EXPORTS) __event = _event;
  else __event = 0;
  prefetch(&state_info);
  {
    struct Fixed_priority_bossa_struct * nxt = tgt_next_list->sched;
    
    if (state_of(nxt) == BLOCKED_STATE) {
      if (nxt->ops->unblock_timer_target(_event, tgt, tgt_next_list->next) == READY) {
        update_state(nxt, READY_STATE, READY);
        move_queue_sorted(nxt /* {blocked} */, &state_info.ready);
      }
      if (state_of(nxt) == READY_STATE) {
        if (empty_proc(state_info.running_0)) {
          return READY;
        }
        else {
          if (greater(nxt, state_info.running_0)) {
            state_info.running_0->ops->preempt();
            update_state(state_info.running_0, READY_STATE, READY);
            move_proc_sorted(state_info.running_0 /* {running_0} */,
                             &state_info.ready);
            return READY;
          }
          else {
            return RUNNING;
          }
        }
      }
      else {
        if (empty_proc(state_info.running_0)) {
          if (empty_proc(state_info.yield) && empty_queue(&state_info.ready)) {
            return BLOCKED;
          }
          else {
            return READY;
          }
        }
        else {
          return RUNNING;
        }
      }
    }
    else {
      switch (nxt->ops->unblock_timer_target(_event, tgt, tgt_next_list->next)) {
        case READY:
          {
            if (!(state_of(nxt) == YIELD_STATE) &&
                (state_of(nxt) == RUNNING_0_STATE)) {
              move_proc_sorted(state_info.running_0 /* {running_0} */,
                               &state_info.ready);
              update_state(nxt, READY_STATE, READY);
            }
            break;
          }
        case BLOCKED:
          {
            switch (state_of(nxt)) {
              case RUNNING_0_STATE:
                {
                  move_proc_queue(state_info.running_0 /* {running_0} */,
                                  &state_info.blocked);
                  break;
                }
              case YIELD_STATE:
                {
                  move_proc_queue(state_info.yield /* {yield} */,
                                  &state_info.blocked);
                  break;
                }
              case READY_STATE:
                {
                  move_queue_queue(nxt /* {ready} */, &state_info.blocked);
                  break;
                }
              case BLOCKED_STATE:
              case TERMINATED_12_STATE:
                {
                  panic("unexpected process state: blocked or terminated_12: file %s line %d",
                          __FILE__, __LINE__);
                  break;
                }
              default:
                panic("unknown state: file: %s, line: %d!.",
                      __FILE__, __LINE__);return 0;
            }
            update_state(nxt, BLOCKED_STATE, BLOCKED);
            break;
          }
        default:
        {
          
        }
      }
      if (empty_proc(state_info.running_0)) {
        if (empty_proc(state_info.yield) && empty_queue(&state_info.ready)) {
          return BLOCKED;
        }
        else {
          return READY;
        }
      }
      else {
        return RUNNING;
      }
    }
  }
}

static int Fixed_priority_unblock_timer_target_entry(int _event,
                                                     struct bossa_struct *tgt,
                                                     struct next_list_struct *next_list) {
  int res;
  res = Fixed_priority_unblock_timer_target(_event,tgt,next_list);
  return res;
}

inline static int
Fixed_priority_unblock_timer_notarget(int _event,
                                      struct bossa_struct *tgt,
                                      struct next_list_struct *tgt_next_list) {
  uint __event;
  // ->prev below gets back to the current scheduler
  if (tgt_next_list->prev->sched->ops == &EXPORTS) __event = _event;
  else __event = 0;
  prefetch(&state_info);
  {
    struct Fixed_priority_bossa_struct * nxt = tgt_next_list->sched;
    
    if (state_of(nxt) == BLOCKED_STATE) {
      if (nxt->ops->unblock_timer_notarget(_event, tgt, tgt_next_list->next) == READY) {
        update_state(nxt, READY_STATE, READY);
        move_queue_sorted(nxt /* {blocked} */, &state_info.ready);
      }
      if (state_of(nxt) == READY_STATE) {
        if (empty_proc(state_info.running_0)) {
          return READY;
        }
        else {
          if (greater(nxt, state_info.running_0)) {
            state_info.running_0->ops->preempt();
            update_state(state_info.running_0, READY_STATE, READY);
            move_proc_sorted(state_info.running_0 /* {running_0} */,
                             &state_info.ready);
            return READY;
          }
          else {
            return RUNNING;
          }
        }
      }
      else {
        if (empty_proc(state_info.running_0)) {
          if (empty_proc(state_info.yield) && empty_queue(&state_info.ready)) {
            return BLOCKED;
          }
          else {
            return READY;
          }
        }
        else {
          return RUNNING;
        }
      }
    }
    else {
      switch (nxt->ops->unblock_timer_notarget(_event, tgt, tgt_next_list->next)) {
        case READY:
          {
            if (!(state_of(nxt) == YIELD_STATE) &&
                (state_of(nxt) == RUNNING_0_STATE)) {
              move_proc_sorted(state_info.running_0 /* {running_0} */,
                               &state_info.ready);
              update_state(nxt, READY_STATE, READY);
            }
            break;
          }
        case BLOCKED:
          {
            switch (state_of(nxt)) {
              case RUNNING_0_STATE:
                {
                  move_proc_queue(state_info.running_0 /* {running_0} */,
                                  &state_info.blocked);
                  break;
                }
              case YIELD_STATE:
                {
                  move_proc_queue(state_info.yield /* {yield} */,
                                  &state_info.blocked);
                  break;
                }
              case READY_STATE:
                {
                  move_queue_queue(nxt /* {ready} */, &state_info.blocked);
                  break;
                }
              case BLOCKED_STATE:
              case TERMINATED_12_STATE:
                {
                  panic("unexpected process state: blocked or terminated_12: file %s line %d",
                          __FILE__, __LINE__);
                  break;
                }
              default:
                panic("unknown state: file: %s, line: %d!.",
                      __FILE__, __LINE__);return 0;
            }
            update_state(nxt, BLOCKED_STATE, BLOCKED);
            break;
          }
        default:
        {
          
        }
      }
      if (empty_proc(state_info.running_0)) {
        if (empty_proc(state_info.yield) && empty_queue(&state_info.ready)) {
          return BLOCKED;
        }
        else {
          return READY;
        }
      }
      else {
        return RUNNING;
      }
    }
  }
}

static int Fixed_priority_unblock_timer_notarget_entry(int _event,
                                                       struct bossa_struct *tgt,
                                                       struct next_list_struct *next_list) {
  int res;
  res = Fixed_priority_unblock_timer_notarget(_event,tgt,next_list);
  return res;
}

static int xcount = 0;
static int total_size = 0;

#define buffer_extend(tmp,size,buffer,ret) \
  do { \
    if (!xcount || size + total_size < xcount) { \
      total_size += size; \
      buffer = size + strcpy(buffer,tmp); \
    } \
    else { \
      return ret; \
    } \
  } while(0)

static int Fixed_priority_do_schedprocinfo(char *buffer, bool long_format) {
  struct Fixed_priority_bossa_struct *p;
  char *orig_buffer = buffer;
  char tmp[500];
  int size;
  
  size = sprintf(tmp,"\t\t\tFixed_priority\n\t\t\t%s\n\n",sched_type[EXPORTS.type]);
  buffer_extend(tmp,size,buffer,total_size);
  size = sprintf(tmp,"Child schedulers:\n");
  buffer_extend(tmp,size,buffer,total_size);
  size = sprintf(tmp, "\t\t%-5s%-15.15s%-5s", "", "Name", "Type");
  buffer_extend(tmp,size,buffer,total_size);
  size = sprintf(tmp, " %-5.4s\n",
  "importance");
  buffer_extend(tmp,size,buffer,total_size);
  
  size = sprintf(tmp, "%-21s","running_0 scheduler: ");
  buffer_extend(tmp,size,buffer,total_size);
  if (!state_info.running_0) {
    size = sprintf(tmp, "null\n");
    buffer_extend(tmp,size,buffer,total_size);
  }
  else {
    p = state_info.running_0;
    size = sprintf(tmp, "%-15.15s%-5s", p->ops->name, sched_type[2+p->ops->type]);
    buffer_extend(tmp,size,buffer,total_size);
    size = sprintf(tmp, " %-5d\n",
    p->importance);
    buffer_extend(tmp,size,buffer,total_size);
  }
  size = sprintf(tmp, "%-21s","ready queue: ");
  buffer_extend(tmp,size,buffer,total_size);
  buffer = queueToString(&state_info.ready,buffer,long_format);
  
  size = sprintf(tmp, "%-21s","yield scheduler: ");
  buffer_extend(tmp,size,buffer,total_size);
  if (!state_info.yield) {
    size = sprintf(tmp, "null\n");
    buffer_extend(tmp,size,buffer,total_size);
  }
  else {
    p = state_info.yield;
    size = sprintf(tmp, "%-15.15s%-5s", p->ops->name, sched_type[2+p->ops->type]);
    buffer_extend(tmp,size,buffer,total_size);
    size = sprintf(tmp, " %-5d\n",
    p->importance);
    buffer_extend(tmp,size,buffer,total_size);
  }
  size = sprintf(tmp, "%-21s","blocked queue: ");
  buffer_extend(tmp,size,buffer,total_size);
  buffer = queueToString(&state_info.blocked,buffer,long_format);
  
  return strlen(orig_buffer); // Should use strnlen ...
}

static char *
queueToString(struct list_head *start, char *buffer, bool long_format) {
  struct Fixed_priority_bossa_struct *p;
  struct list_head *elem;
  char tmp[500];
  int size;
  
  if (list_empty(start)) {
    size = sprintf(tmp,"null\n");
    buffer_extend(tmp,size,buffer,buffer);
  }
  else {
    bool first = true;
    list_for_each(elem, start) {
      p = list_entry(elem, struct Fixed_priority_bossa_struct, list_info);
      if (first) {
        size = sprintf(tmp, "%-15.15s%-5s", p->ops->name, sched_type[2+p->ops->type]);
        buffer_extend(tmp,size,buffer,buffer);
      }
      else {
        size = sprintf(tmp, "\t\t%-5s%-15.15s%-5s", "", p->ops->name, sched_type[2+p->ops->type]);
        buffer_extend(tmp,size,buffer,buffer);
      }
      first = false;
      size = sprintf(tmp, " %-5d\n",
      p->importance);
      buffer_extend(tmp,size,buffer,buffer);
    }
    size = sprintf(tmp, "\n");
    buffer_extend(tmp,size,buffer,buffer);
  }
  return buffer;
}

static int Fixed_priority_do_taskprocinfo(struct next_list_struct *next_list,
                                          struct bossa_struct *bossa,
                                          char *buffer,
                                          bool w_header,
                                          bool long_format,
                                          bool first) {
  char * b = buffer;
  char tmp[500];
  int size;
  
  if (bossa == null) {
    printk("Fixed_priority: Ups! Null process.\n");
    return 0;
  }
  
  if (w_header) {
    size = sprintf(tmp,"Fixed_priority\nname\tstate\timportance\n");
    buffer_extend(tmp,size,buffer,total_size);
    size = sprintf(tmp,"%s	%d\t%-5d\n\n",next_list->next->sched->ops->name,next_list->next->sched->state,
    next_list->next->sched->importance);
    buffer_extend(tmp,size,buffer,total_size);
  }
  next_list->next->sched->ops->do_taskprocinfo(next_list->next,bossa,buffer,w_header,long_format,true);
  return strlen(b); // Should use strnlen ...
}

static int Fixed_priority_list_sched_info(char * page,
                                          char ** start,
                                          off_t off,
                                          int count,
                                          int * eof,
                                          void * data) {
  int res;
  ulong flags=0;
  
  spin_lock_irqsave(&bossa_scheduler_lock,flags);
  xcount = count;
  total_size = 0;
  res = Fixed_priority_do_schedprocinfo(page, true);
  xcount = 0;
  total_size = 0;
  spin_unlock_irqrestore(&bossa_scheduler_lock,flags);
  return res;
}

static void Fixed_priority_print_processes(void) {
  
}

static int Fixed_priority_count_processes(void) {
  int total_49 = 0;
  return 0;
}

/* executed when the scheduler is added to the hierarchy */
static void Fixed_priority_attach_self(void) {
  /* initialization of timer variables */
  
}

static PROTOCOL_SCHEDULER_STRUCT *Fixed_priority_detach_self(bool is_root) {
  if (children == 0) {
    if (EXPORTS.next_list.prev->prev != &(EXPORTS.next_list))
      EXPORTS.next_list.prev->prev->sched->ops->detach(EXPORTS.next_list.prev->sched,true);
    return NULL;
  }
  else if (is_root && children == 1) {
    struct list_head *elem;
    PROTOCOL_SCHEDULER_STRUCT *child;
    
    if (state_info.running_0) {
      child = state_info.running_0;
      Fixed_priority_detach(child,false);
      return child;
    }
    list_for_each(elem, &state_info.ready) {
      child = list_entry(elem, struct Fixed_priority_bossa_struct, list_info);
      Fixed_priority_detach(child,false);
      return child;
    }
    if (state_info.yield) {
      child = state_info.yield;
      Fixed_priority_detach(child,false);
      return child;
    }
    list_for_each(elem, &state_info.blocked) {
      child = list_entry(elem, struct Fixed_priority_bossa_struct, list_info);
      Fixed_priority_detach(child,false);
      return child;
    }
    {
      printk("cannot detach Fixed_priority\n");
      errno = -EINVAL;
      return (PROTOCOL_SCHEDULER_STRUCT *)FAILURE;
    }
  }
  else {
    printk("cannot detach Fixed_priority\n");
    errno = -EINVAL;
    return (PROTOCOL_SCHEDULER_STRUCT *)FAILURE;
  }
  return null;
}

static void Fixed_priority_set_priority(struct bossa_struct *p,
                                        struct next_list_struct *next,
                                        int niceval) {
  return next->sched->ops->set_priority(p,next->next,niceval);
}

// --------------------- interface functions ---------------------
// checksum = 6698


static int major;
static devfs_handle_t devfs_handle;
static devfs_handle_t devfs_handle2;
extern spinlock_t bossa_scheduler_lock;


#define BOSSA_ID_NUM 0xCE
#define IOCTL_SETIMPORTANCE     _IOW(BOSSA_ID_NUM, 0, int)
#define BOSSA_DEVICE_NAME "bossa_Fixed_priority"


static inline struct bossa_struct *find_process_by_pid(pid_t pid) {
  struct task_struct *tsk;
  
  if (pid) {
    //read_lock_irq(&tasklist_lock);
    tsk = find_task_by_pid(pid);
    //read_unlock_irq(&tasklist_lock);
  }
  else tsk = current;
  return (struct bossa_struct *)(&tsk->bossa);
}

struct dev_Fixed_priority_attach_struct {
  int parent;
  int child;
  int data[10];
};

struct dev_Fixed_priority_setImportance_struct {
  int s;
  int priority;
};


static inline int _dev_Fixed_priority_ioctl(uint ioctl_num,
                                            ulong param) {
  errno = 0;
  if (EXPORTS.next_list.next == &(EXPORTS.next_list)) {
    printk("Fixed_priority not loaded\n");
    errno = -EINVAL;
    return FAILURE;
  }
  switch (ioctl_num) {
    case IOCTL_SETIMPORTANCE: {
      struct dev_Fixed_priority_setImportance_struct data;
      struct Fixed_priority_bossa_struct * s;
      struct scheduler_operations *s_tmp;
      int priority;
      copy_from_user(&data,
                     (struct dev_Fixed_priority_setImportance_struct *)param,
                     sizeof(struct dev_Fixed_priority_setImportance_struct));
      s_tmp = find_scheduler_by_id(data.s);
      priority = data.priority;
      if (s_tmp==null) {
        printk("unknown scheduler\n");
        errno = -EINVAL;
        return FAILURE;
      }
      // the following should be ok because the scheduler is not the root
      if (s_tmp->next_list.prev->prev->sched->ops != &EXPORTS) {
        printk("scheduler argument s must be managed by the current scheduler\n");
        errno = -EINVAL;
        return FAILURE;
      }
      {
        struct Fixed_priority_bossa_struct *s_tmp2;
        struct list_head *_fresh_50;
        list_for_each(_fresh_50, &state_info.blocked) {
          s_tmp2 = list_entry(_fresh_50, struct Fixed_priority_bossa_struct, list_info);
          if (s_tmp2->ops == s_tmp) {
            s = s_tmp2;
            goto s_ok;
          }
        }
      }
      {
        struct Fixed_priority_bossa_struct *s_tmp2 = state_info.yield;
        if (s_tmp2) {
          if (s_tmp2->ops == s_tmp) {
            s = s_tmp2;
            goto s_ok;
          }
        }
      }
      {
        struct Fixed_priority_bossa_struct *s_tmp2;
        struct list_head *_fresh_51;
        list_for_each(_fresh_51, &state_info.ready) {
          s_tmp2 = list_entry(_fresh_51, struct Fixed_priority_bossa_struct, list_info);
          if (s_tmp2->ops == s_tmp) {
            s = s_tmp2;
            goto s_ok;
          }
        }
      }
      {
        struct Fixed_priority_bossa_struct *s_tmp2 = state_info.running_0;
        if (s_tmp2) {
          if (s_tmp2->ops == s_tmp) {
            s = s_tmp2;
            goto s_ok;
          }
        }
      }
      printk("scheduler not found\n");
      errno = -EINVAL;
      return FAILURE;
      s_ok:
      {
        s->importance = priority;
        switch (state_of(s)) {
          case RUNNING_0_STATE:
            {
              if (empty_queue(&state_info.ready)) {
                goto out_setImportance;
              }
              else {
                if (greater(select_sorted(&state_info.ready),
                            state_info.running_0)) {
                  state_info.running_0->ops->preempt();
                  update_state(state_info.running_0, READY_STATE, READY);
                  move_proc_sorted(state_info.running_0 /* {running_0} */,
                                   &state_info.ready);
                  goto out_setImportance;
                }
                else {
                  goto out_setImportance;
                }
              }
              break;
            }
          case READY_STATE:
            {
              if (empty_proc(state_info.running_0)) {
                goto out_setImportance;
              }
              else {
                if (greater(s, state_info.running_0)) {
                  state_info.running_0->ops->preempt();
                  update_state(state_info.running_0, READY_STATE, READY);
                  move_proc_sorted(state_info.running_0 /* {running_0} */,
                                   &state_info.ready);
                  goto out_setImportance;
                }
                else {
                  goto out_setImportance;
                }
              }
              break;
            }
          case BLOCKED_STATE:
          case YIELD_STATE:
            {
              goto out_setImportance;
              break;
            }
          default:
            panic("unknown state: file: %s, line: %d!.",
                  __FILE__, __LINE__);return 0;
        }
      }
      out_setImportance:
      root_s_state =
        EXPORTS.next_list.next->sched->ops->compute_state(EXPORTS.next_list.next->next);
      return SUCCESS;
    }
  }
  printk("error occurred in Fixed_priority\n");
  errno = -EINVAL;
  return FAILURE;
}

static int dev_Fixed_priority_ioctl(struct inode *inode,
                                    struct file *fd,
                                    uint ioctl_num,
                                    ulong param) {
  int res;
  ulong flags=0;
  
  spin_lock_irqsave(&bossa_scheduler_lock,flags);
  res = _dev_Fixed_priority_ioctl(ioctl_num,param);
  spin_unlock_irqrestore(&bossa_scheduler_lock,flags);
  return res;
}

static struct file_operations procfops = {
  ioctl: dev_Fixed_priority_ioctl
};


static int __init Fixed_priority_ioctl_init(void) {
  devfs_handle = devfs_mk_dir (null, "bossa", null);
  major = devfs_register_chrdev(0, BOSSA_DEVICE_NAME, &procfops);
  if (major < 0) {
    printk("devfs_register_chrdev failed\n");
    return -ENODEV;
  }
  devfs_handle2 = devfs_register(devfs_handle, BOSSA_DEVICE_NAME, DEVFS_FL_DEFAULT,
                                  major, 0,
                                  S_IFCHR | S_IRUGO | S_IWUGO,
                                  &procfops, NULL);
  return 0;
}

static int
Fixed_priority_attach(struct Fixed_priority_bossa_struct *s_9,
                      int data[]) {
  int _i = 0;
  int importance_10 = data[_i++];
  {
    s_9->importance = importance_10;
    increment_ref_count();
    return SUCCESS;
  }
}

static int Fixed_priority_attach_info(char *info[]) {
  info[0] = "int importance_10";
  return 1;
}

static int Fixed_priority_detach(struct Fixed_priority_bossa_struct *_s,
                                 int discard_child) {
  struct Fixed_priority_bossa_struct *s = (struct Fixed_priority_bossa_struct *)_s;
  {
    decrement_ref_count();
    if (discard_child) {
      if (state_of(s) == BLOCKED_STATE) {
        update_state(s, TERMINATED_12_STATE, TERMINATED);
        move_queue_nowhere(s /* {blocked} */, &state_info.terminated_12);
        kfree(s);
      }
      else {
        printk("bad state\n");
        errno = -EINVAL;
        return FAILURE;
        
      }
    }
    else {
      if (state_of(s) == RUNNING_0_STATE) {
        update_state(s, TERMINATED_12_STATE, TERMINATED);
        move_proc_nowhere(state_info.running_0 /* {running_0} */,
                          &state_info.terminated_12);
      }
      else {
        update_state(s, TERMINATED_12_STATE, TERMINATED);
        move_queue_nowhere(s /* {ready, blocked} */, &state_info.terminated_12);
      }
      kfree(s);
    }
    children = children - 1;
    return SUCCESS;
  }
}

#ifdef MODULE
static void unregister(void) {
  devfs_unregister_chrdev(major, BOSSA_DEVICE_NAME);
  devfs_unregister(devfs_handle2);
}
#endif
